﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{

	import com.actionscriptfacile.ui.text.UITextField;
	
	import com.google.maps.Color;
	import com.google.maps.overlays.MarkerOptions;
	import com.google.maps.services.DirectionsEvent;
	import com.google.maps.services.Directions;
	import com.google.maps.controls.MapTypeControl;
	import com.google.maps.controls.PositionControl;
	import com.google.maps.MapMoveEvent;
	import com.google.maps.MapMouseEvent;
	import com.google.maps.InfoWindowOptions;
	import com.google.maps.MapOptions;
	import com.google.maps.overlays.Marker;
	import com.google.maps.LatLngBounds;
	import com.google.maps.LatLng;
	import com.google.maps.MapType;
	import com.google.maps.MapEvent;
	import com.google.maps.Map;
	
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	import flash.geom.Point;
	import flash.events.Event;
	import flash.display.Sprite;

	import com.demonsters.debugger.MonsterDebugger;

	
	/**
	 * La classe Main qui étend Sprite.
	 * définit le nombre d'images par secondes dans les paramètres de compilation
	 * -default-frame-rate 10
	 * 
	 * 
	 * Les démos d'utilisation de Google Map Flash : http://code.google.com/intl/fr-FR/apis/maps/documentation/flash/demogallery.html
	 * La documentation de l'API : http://code.google.com/intl/fr-FR/apis/maps/documentation/flash/examples/index.html
	 * Création de cartes 3D en flash : http://code.google.com/intl/fr-FR/apis/maps/documentation/flash/3d-maps.html
	 * 
	 */
	public class Main extends Sprite
	{
		// clé API Google Map, à générer ici : http://code.google.com/apis/maps/signup.html
		private static const API_KEY : String = "ABQIAAAAUUPM2YTPbv1Mom3_EFyc_BTtbp2H4cHMNwiMGXghqrSl3NkR7xQBAD5jpCQywkbRokxaxG5SvJ5TQQ";
		
		private var map : Map;
		private var myTimer : Timer;

		private var message : Array = ["C'est", "un", "message", "secret", "à découvrir..."];
		
		private var dir : Directions;
		
		private var nStepCounter : uint;
		private var oTxtFrom : UITextField;
		private var oTxtTo : UITextField;
		private var oTxtEtapes : UITextField;
		

		/**
		 * Constructeur.
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * -default-frame-rate 10
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);

			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Start Application");
			
			setupUi();
			setupControl();
		}

		
		/**
		 * Préparation des boutons de controles de la carte.
		 * 
		 */
		private function setupControl() : void
		{
			// Création du bouton Play / Pause
			var oBtnZoomOut:DefaultButton = new DefaultButton();
			oBtnZoomOut.getObject().label = "Zoom --";
			oBtnZoomOut.getObject().x = stage.stageWidth-10-oBtnZoomOut.getObject().width;
			oBtnZoomOut.getObject().y = 10;
			oBtnZoomOut.getObject().addEventListener ( MouseEvent.CLICK, onZoomOut );
			
			var oBtnZoomIn:DefaultButton = new DefaultButton();
			oBtnZoomIn.getObject().label = "Zoom ++";
			oBtnZoomIn.getObject().x = oBtnZoomOut.getObject().x;
			oBtnZoomIn.getObject().y = oBtnZoomOut.getObject().y + oBtnZoomOut.getObject().height + 10;
			oBtnZoomIn.getObject().addEventListener ( MouseEvent.CLICK, onZoomIn );
			
			oTxtFrom = new UITextField();
			oTxtFrom.x = oBtnZoomOut.getObject().x;
			oTxtFrom.y = oBtnZoomIn.getObject().y + oBtnZoomIn.getObject().height + 10;
			oTxtFrom.maxWidth = oTxtFrom.width = 103;
			oTxtFrom.maxHeight = oTxtFrom.height = 20;
			oTxtFrom.text = "Départ";
			oTxtFrom.convertToInput();
			oTxtFrom.alignLeft(); // aligne le texte
			oTxtFrom.background = true;
			oTxtFrom.backgroundColor = 0X00CCCCCC;
			oTxtFrom.changeFormat("size", 10);// changement de la taille de la police du texte
			oTxtFrom.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtFrom.changeFormat("color", 0X00FFFFFF);// changement de la couleur
			
			oTxtTo = new UITextField();
			oTxtTo.x = oBtnZoomOut.getObject().x;
			oTxtTo.y = oTxtFrom.y + oTxtFrom.height + 10;
			oTxtTo.maxWidth = oTxtTo.width = 103;
			oTxtTo.maxHeight = oTxtTo.height = 20;
			oTxtTo.text = "Arrivée";
			oTxtTo.convertToInput();
			oTxtTo.alignLeft(); // aligne le texte
			oTxtTo.background = true;
			oTxtTo.backgroundColor = 0X00CCCCCC;
			oTxtTo.changeFormat("size", 10);// changement de la taille de la police du texte
			oTxtTo.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtTo.changeFormat("color", 0X00FFFFFF);// changement de la couleur
			
			var oBtnGetDirections:DefaultButton = new DefaultButton();
			oBtnGetDirections.getObject().label = "Calcul Itinéraire";
			oBtnGetDirections.getObject().x = oBtnZoomOut.getObject().x;
			oBtnGetDirections.getObject().y = oTxtTo.y + oTxtTo.height + 10;
			oBtnGetDirections.getObject().addEventListener ( MouseEvent.CLICK, onProcessDirections );
			
			var oBtnNextStep:DefaultButton = new DefaultButton();
			oBtnNextStep.getObject().label = "Etape suivante";
			oBtnNextStep.getObject().x = oBtnZoomOut.getObject().x;
			oBtnNextStep.getObject().y = oBtnGetDirections.getObject().y + oBtnGetDirections.getObject().height + 10;
			oBtnNextStep.getObject().addEventListener ( MouseEvent.CLICK, onNextStep );
			
			oTxtEtapes = new UITextField();
			oTxtEtapes.x = oBtnZoomOut.getObject().x;
			oTxtEtapes.y = oBtnNextStep.getObject().y + oBtnNextStep.getObject().height + 10;
			oTxtEtapes.maxWidth = oTxtEtapes.width = 100;
			oTxtEtapes.htmlText = " ";
			oTxtEtapes.wordWrap = true;
			oTxtEtapes.convertToDynamic();
			oTxtEtapes.autoSizeLeft();
			oTxtEtapes.selectable = false;
			oTxtEtapes.alignLeft(); // aligne le texte
			oTxtEtapes.changeFormat("size", 10);// changement de la taille de la police du texte
			oTxtEtapes.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtEtapes.changeFormat("color", Math.random() * 0X00FFFFFF);// changement de la couleur
			
			addChild(oBtnZoomOut);
			addChild(oBtnZoomIn);
			addChild(oTxtFrom);
			addChild(oTxtTo);
			addChild(oBtnGetDirections);
			addChild(oBtnNextStep);
			addChild(oTxtEtapes);
		}

	

		/**
		 * Initialisation de l'interface utilisateur.
		 * 
		 */
		private function setupUi() : void
		{
			map = new Map();
			map.key = API_KEY;
			map.sensor = "false";// détection de la position via un GPS
			map.setSize(new Point(stage.stageWidth-130, stage.stageHeight));// taille de la carte
			
			map.addEventListener(MapEvent.MAP_READY, onMapReady);
			map.addEventListener(MapEvent.MAP_PREINITIALIZE, onMapInit);
			//map.addEventListener(MapMouseEvent.CLICK, onMapClick);
			//map.addEventListener(MapMoveEvent.MOVE_END, onMapMoveEnd);
			
			this.addChild(map);
		}
		
		
		
		/**
		 * Initialisation de la carte.
		 * 
		 */
		private function onMapInit(event : MapEvent) : void
		{
			MonsterDebugger.trace(this, "onMapInit");

			var myMapOptions : MapOptions = new MapOptions();
			myMapOptions.zoom = 14;
			myMapOptions.center = new LatLng(47.349756, -2.511606);
			
			/*
			Les différents types de cartes
			NORMAL_MAP_TYPE - vue par défaut
			SATELLITE_MAP_TYPE - affiche les images satellite de Google Earth 
			HYBRID_MAP_TYPE - affiche un mixte entre le mode normal et les imagse satellites
			PHYSICAL_MAP_TYPE - affiche le relief de la terre.
			DEFAULT_MAP_TYPES - un tableau avec les différents types pour les processus itératifs.
 			*/
			myMapOptions.mapType = MapType.NORMAL_MAP_TYPE;
			
			this.map.setInitOptions(myMapOptions);
		}
		
		
		/**
		 * La carte google est prête à être utilisée.
		 * 
		 */
		private function onMapReady(event : Event) : void
		{
			MonsterDebugger.trace(this, "onMapReady");
			// coordonnées de la zone - le type de carte (satellite...)
			//map.setCenter(new LatLng(40.736072, -73.992062), 14, MapType.HYBRID_MAP_TYPE);
			
			map.openInfoWindow(map.getCenter(), new InfoWindowOptions({title: "Bienvenue en Bretagne", content: "Visitez la ville de La Turballe"}));
			
			
			/*var bottomRight : ControlPosition = new ControlPosition(ControlPosition.ANCHOR_BOTTOM_RIGHT, 16, 10);
			var myMapTypeControl : MapTypeControl = new MapTypeControl();
			myMapTypeControl.setControlPosition(bottomRight);
			map.addControl(myMapTypeControl);*/
			
			// active les contrôles sur la carte 
			//map.addControl(new ZoomControl());
			map.addControl(new PositionControl());
			map.addControl(new MapTypeControl());

			// Add 10 markers to the map at random locations
			var bounds : LatLngBounds = map.getLatLngBounds();
			var southWest : LatLng = bounds.getSouthWest();
			var northEast : LatLng = bounds.getNorthEast();
			var lngSpan : Number = northEast.lng() - southWest.lng();
			var latSpan : Number = northEast.lat() - southWest.lat();
			
			for (var i : int = 0; i < 10; i++)
			{
				var newLat : Number = southWest.lat() + (latSpan * Math.random());
				var newLng : Number = southWest.lng() + (lngSpan * Math.random());
				var latlng : LatLng = new LatLng(newLat, newLng);
				
				map.addOverlay(createMarker(latlng, i + 1));
			}
			
			myTimer = new Timer(5000, 1);
			myTimer.addEventListener("timer", timedFunction);
			//myTimer.start();
			
			// création d'un itinéraire
			dir = new Directions();
			dir.addEventListener(DirectionsEvent.DIRECTIONS_SUCCESS, onDirLoad);
			dir.addEventListener(DirectionsEvent.DIRECTIONS_FAILURE, onDirFail);	
		}
		
		
		/**
		 * Itinéraire calculé.
		 * Mise à jour de la carte.
		 * 
		 */
		private function onDirLoad(event : DirectionsEvent) : void
		{
			var dirD : Directions = Directions (event.directions);
			var startMarker : Marker;
			var endMarker : Marker;

			map.clearOverlays();
			map.addOverlay(dirD.createPolyline());
			map.setZoom(map.getBoundsZoomLevel(dirD.bounds));
			map.setCenter(dirD.bounds.getCenter());

			startMarker = new Marker(dirD.getRoute(0).startGeocode.point, new MarkerOptions({fillStyle:{color:Color.GREEN}}));
			endMarker = new Marker(dirD.getRoute(0).endGeocode.point, new MarkerOptions({fillStyle:{color:Color.BLUE}}));
			map.addOverlay(startMarker);
			map.addOverlay(endMarker);
		}
		
		
		/**
		 * Calcul de l'itinéraire à partir des données de l'utilisateur.
		 * 
		 */
		private function onProcessDirections(event : MouseEvent) : void
		{
			dir.load("from: " + oTxtFrom.text + " to: " + oTxtTo.text);
			nStepCounter = 0;// mise à 0 du compteur pour l'affichage des étapes.
			oTxtEtapes.htmlText = "Départ de " + oTxtFrom.text;
		}
  
		
		/**
		 * Affiche l'étape suivante dans l'itinéraire.
		 * 
		 */
		private function onNextStep(event : MouseEvent) : void
		{
			nStepCounter++;// incrémente le nombre d'étapes pour afficher l'itinéraire.
			
			if (nStepCounter <= dir.getRoute(0).numSteps)
			{
				var stepText:String = dir.getRoute(0).getStep(nStepCounter - 1).descriptionHtml;
				var stepMarker:Marker = new Marker(dir.getRoute(0).getStep(nStepCounter - 1).latLng, new MarkerOptions({label:nStepCounter.toString()}));
				map.addOverlay(stepMarker);
				oTxtEtapes.htmlText = "Etape " + nStepCounter + ": " + stepText+" - TRAJET : "+dir.getRoute(0).summaryHtml;
			}
			else	oTxtEtapes.htmlText = "Arrivée à " + oTxtTo.text + " - TRAJET : " + dir.getRoute(0).summaryHtml;
		}
		
		
		/**
		 * Erreur de calcul de l'itinéraire.
		 * 
		 */
		private function onDirFail(event : DirectionsEvent) : void
		{
			MonsterDebugger.trace(this, "Erreur d'itinéraire : " + event.directions.status);
			oTxtEtapes.htmlText = "Erreur dans l'itinéraire !!! Veuillez corriger les informations.";
		}
		
		
		
		/**
		 * Création d'un favori.
		 * 
		 */
		private function createMarker(latlng : LatLng, number : Number) : Marker
		{
			var marker : Marker = new Marker(latlng);
			marker.addEventListener(MapMouseEvent.CLICK, function(e : MapMouseEvent) : void
			{
				var myTitle : String = "<b>#" + number + "</b>";
				var myContent : String = message[number - 1];
				map.openInfoWindow(latlng, new InfoWindowOptions({titleHTML:myTitle, contentHTML:myContent}));
			});
			return marker;
		}

		private function timedFunction(eventArgs : TimerEvent) : void
		{
			map.panTo(new LatLng(37.4569, -122.1569));
			MonsterDebugger.trace(this, "Timer fired " + myTimer.currentCount + " times.");
		}
		
		
		/**
		 * Lors du clique par l'utilisateur sur la carte.
		 * 
		 */
		private function onMapClick(event : MapMouseEvent) : void
		{
			map.openInfoWindow(event.latLng, new InfoWindowOptions({title:"Evènement Click", content:"Vous avez cliqué sur la carte!"}));
		} 
		
		
		/**
		 * Lors du déplacement de la carte par l'utilisateur.
		 * 
		 */
		private function onMapMoveEnd(event : MapMoveEvent) : void
		{
			var center : LatLng = map.getCenter();
			map.openInfoWindow(center, new InfoWindowOptions({title:"Evènement mouvement de la carte", content:"Vous avez bougé la carte"}));
		} 
		
		
		/**
		 * Agrandissement de la carte.
		 * 
		 */
		private function onZoomIn(event : MouseEvent) : void
		{
			map.zoomIn();
		}
		
		/**
		 * Réduction de la carte.
		 * 
		 */
		private function onZoomOut(event : MouseEvent) : void
		{
			map.zoomOut();
		}
		
	}
}
